
var publiwide = publiwide || {};
publiwide.androidAnnotations = {};

publiwide.androidAnnotations =
{
    addHighlightFromUserSelection: function(category){
        
        var result = publiwide.annotations.getHighlightFromUserSelection(null, category);
        //publiwide.annotations.addHighlight(result);
        publiwide.annotations.display(result, null);
        if(window.AnnotationsController) {
            window.AnnotationsController.addHighlight(result.category, result.cType, result.data.toString(), result.key, result.text, result.created);
        }else{
            android.selection.getReadiumFrame().contentWindow.AnnotationsController.addHighlight(result.category, result.cType, result.data.toString(), result.key, result.text, result.created);
        }
    },

    addNoteFromUserSelection: function(category, userText){
        
        var result = publiwide.annotations.getNoteFromUserSelection(null, category);
        result.userText = userText;
        //publiwide.annotations.addNote(result);
        publiwide.annotations.display(result, null);
        if(window.AnnotationsController) {
            window.AnnotationsController.addNote(result.category, result.cType, result.data.toString(), result.isPublic, result.key, result.publicUserName, result.text, result.userText, result.created);
        }else{
            android.selection.getReadiumFrame().contentWindow.AnnotationsController.addNote(result.category, result.cType, result.data.toString(), result.isPublic, result.key, result.publicUserName, result.text, result.userText, result.created);
        }
    },

    addHighlightToSync: function(key, category, text, data, id){
        
        var highlight = null;
        highlight = new Highlight(data);
        highlight.category = category;
        highlight.text = text;
        highlight.key = key;
        publiwide.annotations.addHighlight(highlight);
    },

    addNoteToSync: function(key, category, text, userText, data, id){
        
        var note = null;
        note = new Note(data);
        note.category = category;
        note.userText = userText;
        note.text = text;
        note.key = key;
        publiwide.annotations.addNote(note);
    },

    hideAll: function(){
        
        publiwide.annotations.hideAll();
    },

    displayHighlight: function(key, category, text, data, id){
        
        var highlight = null;
        highlight = new Highlight(data);
        highlight.category = category;
        highlight.text = text;
        highlight.key = key;
        highlight.id = id;
        highlight.cType = 'epubcfi';
        publiwide.annotations.refresh(highlight);
    },

    displayNote: function(key, category, text, userText, data, id){
        
        var note = null;
        note = new Note(data);
        note.category = category;
        note.userText = userText;
        note.text = text;
        note.key = key;
        note.id = id;
        note.cType = 'epubcfi';
        publiwide.annotations.refresh(note);
    },

    highlightClick: function(highlight) {
        if(window.AnnotationsController) {
            window.AnnotationsController.highlightClick(highlight.key, highlight.id);
        }else{
            android.selection.getReadiumFrame().contentWindow.AnnotationsController.highlightClick(highlight.key, highlight.id);
        }
    },

    noteClick: function(note){
        if(window.AnnotationsController) {
            window.AnnotationsController.noteClick(note.key, note.id);
        }else{
            android.selection.getReadiumFrame().contentWindow.AnnotationsController.noteClick(note.key, note.id);
        }
    },

    removeAnnotationSync: function(annotation){
        if(window.AnnotationsController) {
            window.AnnotationsController.removeAnnotationSync(annotation.key, annotation.id);
        }else{
            android.selection.getReadiumFrame().contentWindow.AnnotationsController.removeAnnotationSync(annotation.key, annotation.id);
        }
    },

    syncHighlight: function(highlight){
        if(window.AnnotationsController) {
            window.AnnotationsController.syncHightlight(highlight.category, highlight.cType, highlight.data.toString(), highlight.key, highlight.text, highlight.modified, highlight.id);
        }else{
            android.selection.getReadiumFrame().contentWindow.AnnotationsController.syncHightlight(highlight.category, highlight.cType, highlight.data.toString(), highlight.key, highlight.text, highlight.modified, highlight.id);
        }
    },

    syncNote: function(note){
        if(window.AnnotationsController) {
            window.AnnotationsController.syncNote(note.category, note.cType, note.data.toString(),	note.isPublic, note.key, note.publicUserName, note.text, note.userText, note.modified, note.id);
        }else{
            android.selection.getReadiumFrame().contentWindow.AnnotationsController.syncNote(note.category, note.cType, note.data.toString(),	note.isPublic, note.key, note.publicUserName, note.text, note.userText, note.modified, note.id);
        }
    },

    deleteHighlight: function(key, category, text, data, id){
        
        var highlight = null;
        highlight = new Highlight(data);
        highlight.category = category;
        highlight.text = text;
        highlight.key = key;
        highlight.id = id;
        publiwide.annotations.hide(highlight);
        publiwide.annotations.remove(highlight);
    },

    deleteNote: function(key, category, text, userText, data, id){
        
        var note = null;
        note = new Note(data);
        note.category = category;
        note.userText = userText;
        note.text = text;
        note.key = key;
        note.id = id;
        publiwide.annotations.hide(note);
        publiwide.annotations.remove(note);
    },

    modifyHighlight: function(key, category, text, data, id, update, syncOnly){
        
        var highlight = null;
        highlight = new Highlight(data);
        highlight.category = category;
        highlight.text = text;
        highlight.key = key;
        highlight.id = id;
        highlight.modified = publiwide.utils.getDate(new Date()).format('yyyy-mm-dd HH:MM:ss', true);
        if(id != 0 && update) {
            publiwide.annotations.addHighlight(highlight);
        }
        if(!syncOnly) {
            publiwide.annotations.hide(highlight);
            publiwide.annotations.display(highlight);
        }
    },

    modifyNote: function(key, category, text, userText, data, id, update, syncOnly){
        
        var note = null;
        note = new Note(data);
        note.category = category;
        note.userText = userText;
        note.text = text;
        note.key = key;
        note.id = id;
        note.modified = publiwide.utils.getDate(new Date()).format('yyyy-mm-dd HH:MM:ss', true);
        if(id != 0 && update) {
            publiwide.annotations.addNote(note);
        }
        if(!syncOnly) {
            publiwide.annotations.hide(note);
            publiwide.annotations.display(note);
        }
    },
    startSync: function(deviceId, bookId){
        publiwide.currentCFI =viewAnnot.getCurrentCFI();
        publiwide.sync._init(deviceId, bookId);
    }

    /*

    jumpToData: function(data){
        console.debug("jumpData: " + data);
        publiwide.viewAnnot.jumpToCFI(data, null);
    }*/
}