/*
 Copyright (c) 2014 Publiwide
 http://www.publiwide.com

 Created: 9/11/14 12:26 PM
 Authors: Alexandru Popa, alexandru.popa@publiwide.com
 */

var publiwide = publiwide || {};

publiwide.Reader =
{
	_zoom: 3,
	_zoomSizes: [0.25, 0.5, 0.75, 1, 1.25, 1.5, 1.75, 2],
	element: null,

	getIframe: function()
	{
		var result = document.getElementById("epubContentIframe");
		if (result == null)
		{
			result = document.getElementsByTagName("IFRAME");
			if (result != null && result.length > 0)
				return result[0];
		}
		if (result != null && result.nodeName == "IFRAME")
			return result;
		return null;
	},

	getBody: function()
	{
		var doc = publiwide.Reader.getDocument();
		if (doc != null) {
            return doc.getElementsByTagName("body")[0];
        }else {
            var w = publiwide.Reader.getWindow();
        }
		if (w != null) {
            return publiwide.Reader.element.contentWindow.document.body;
        }
		return null;
	},
	getCurrentCFI: function()
	{
        /*var result = publiwide.currentCFI;
        if (typeof publiwide.currentCFI == 'object' && typeof publiwide.currentCFI.value == 'string')
            result = publiwide.currentCFI.value.substr(0, publiwide.currentCFI.value.length - 1);
        else if (typeof publiwide.currentCFI == 'string' && !publiwide.currentCFI.startsWith('epubcfi'))
            result = 'epubcfi(' + publiwide.currentCFI + ')';*/

		var rs = ReadiumSDK.reader.getCurrentSelectionCfi();
        var idref = (typeof rs == 'object' && typeof rs.idref == 'string' && rs.idref.length > 0) ? rs.idref : "";
        var result = "epubcfi({" + idref + "}!0:0)";

        return new publiwide.CFI(result);
	},
	getDocument: function()
	{
        publiwide.Reader.element = publiwide.Reader.getIframe();
		if (publiwide.Reader.element != null)
		{
			if (publiwide.Reader.element.contentDocument) {
                return publiwide.Reader.element.contentDocument;
            }else if (publiwide.Reader.element.contentWindow){
                return publiwide.Reader.element.contentWindow.document;
            }
		}
		return document;

	},
	getWindow: function()
	{
		publiwide.Reader.element = publiwide.Reader.getIframe();
		return publiwide.Reader.element != null ? publiwide.Reader.element.contentWindow : window;

	},
	is43: function()
	{
		return screen.width / screen.height < 1.4;
	},
	isEnoughWidth: function()
	{
		return screen.width - 480 > 800;
	},
	isSVG: function()
	{
		var b = publiwide.Reader.getBody();
		if (b != null)
		{
			var svg = b.getElementsByTagName('svg');
			for (var i = 0; i < svg.length; i++)
			{
				if (!svg[i].hasAttribute('type') && (svg[i].parentNode == b || (svg[i].parentNode != null && svg[i].parentNode.parentNode == b)))
					return true;
			}
		}
		return false;
	},

	jumpTo: function(element, animationDuration, callback, spatial)
	{
		if (element == null)
			return;
		animationDuration = typeof animationDuration == 'number' ? animationDuration : 0;
		var parent = element;
		while (parent != null &&  parent.nodeType != 1)
			parent = parent.parentNode;
		if (parent != null)
		{
			if (publiwide.Reader.getWindow().jQuery)
			{
				var span = publiwide.Reader.getDocument().createElement("span");
				$(element).replaceWith(span);
				span.appendChild(element);
				var top = $(span).offset().top - 10;
				if (typeof spatial == 'object' && spatial != null && typeof spatial.X == 'number' && typeof spatial.Y == 'number')
					top *= spatial.Y;
				if (animationDuration > 0)
					$(publiwide.Reader.getBody()).animate({scrollTop: top + "px"}, animationDuration, "swing", function() { $(span).replaceWith(element)});
				else
				{
					publiwide.Reader.getBody().scrollTop = top;
					$(span).replaceWith(element);
				}
			}
			else
			{
				var top = parent.offsetTop;
				if (typeof spatial == 'object' && spatial != null && typeof spatial.X == 'number' && typeof spatial.Y == 'number')
					top *= spatial.Y;
				publiwide.Reader.getBody().scrollTop = top;
			}
		}
	},
	jumpToAnnotation: function(annotation)
	{
		if (typeof annotation == 'undefined')
			return false;
		publiwide.Reader.jumpToCFI(annotation.data);
	},
	_jumpToCFI: function(data, callback)
	{
		var range = annotations.getRange(data.value);
		var cfi = new publiwide.CFI(data.value);
		if (range != null && range.startContainer != null)
			publiwide.Reader.jumpTo(range.startContainer, 500, null, cfi.spatial);
		if (typeof callback == 'function')
			callback();
	},
	jumpToCFI: function(data, callback)
	{
		if (typeof data == 'string')
			data = new publiwide.CFI(data);
		/*if (data.toc != null)
		 {
		 var currentCFI = toc.getCurrentCFI();
		 toc.load(data.toc, true, function()
		 {

		 });
		 }
		 else
		 */publiwide.Reader._jumpToCFI(data, callback);
	},
	idref: null,
	getPosition: function()
	{
		var te = utils.getTopElement();
		return utils.findPosY(te);
	}
};
var viewAnnot = publiwide.Reader;