/*
 Copyright (c) 2014 Publiwide
 http://www.publiwide.com

 Created: 3/18/14 11:22 AM
 Authors: Alexandru Popa, alexandru.popa@publiwide.com
 */

var publiwide = publiwide || {};
publiwide.web = publiwide.web || {};

publiwide.web.WebServiceStatus =
{
    OK: 'OK',
    ERROR: 'ERROR',
    INCOMPLETE: 'INCOMPLETE',
    ZERO_RESULTS: 'ZERO_RESULTS',
    REQUEST_DENIED: 'REQUEST_DENIED',
    INVALID_REQUEST: 'INVALID_REQUEST',
    LOGIN_REQUIRED: 'LOGIN_REQUIRED',
    ALREADY_LOGGED_IN: 'ALREADY_LOGGED_IN'
};

publiwide.web.WebServiceResult = function(data)
{
    try
    {
        if (typeof data == 'string') {
            this.data = JSON.parse(data);
        }else {
            this.data = data;
        }
    }
    catch (e)
    {
        return;
    }

    for (var field in this.data) {
        this[field] = this.data[field];
    }
    delete this.data;

    this.count = function()
    {
        if (this.successful() && this.result != null)
            return this.result.length;
        return 0;
    };
    this.successful = function()
    {
        return this.status == WebServiceStatus.OK || this.status == WebServiceStatus.ZERO_RESULTS;
    };
};

publiwide.web.services =
{
    url: 'http://edelivery.publiwide.com/services/',

    call: function(service, method, args, success, error, done)
    {
        $.ajax(
            {
                url: publiwide.web.services.url + service + '/' + method + '/json;',
                type: 'POST',
                data: args,
                async: true,
                error: function(jqXHR, textStatus, errorThrown)
                {

                    if (error != null)
                        error(textStatus, errorThrown);
                    if (done != null)
                        done(d);
                }
            }).done(function(data)
            {
                var d = new publiwide.web.WebServiceResult(data);
                if (success != null)
                    success(d);
                if (done != null)
                    done(d);
            });
    }
};

var WebServiceStatus = publiwide.web.WebServiceStatus;